<?php
	class ghl_menu_custom_fields {
		public $fields_name;

	    /**
	     * Contient les champs personnalisés
	     */
		protected static $fields = array();


	    /**
	     * Initialiser les champs personnalisés
	     */
		public static function init() {
			add_action( 'wp_nav_menu_item_custom_fields', array( __CLASS__, '_fields' ), 10, 4 );
			add_action( 'wp_update_nav_menu_item', array( __CLASS__, '_save' ), 10, 3 );
			add_filter( 'manage_nav-menus_columns', array( __CLASS__, '_columns' ), 99 );
			self::$fields = array(
				'ghostlink' => [
					'type' => 'select',
					'value' => 'hidden'
				],
			);
		}

	    /**
	     * Sauvegarder la valeur du champ personnalisé
	     */
		public static function _save( $menu_id, $menu_item_db_id, $menu_item_args ) {
			if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) {
				return;
			}
			check_admin_referer( 'update-nav_menu', 'update-nav-menu-nonce' );
			foreach ( self::$fields as $_key => $label ) {
				$key = sprintf( 'menu-item-%s', $_key );

				// Assainir
				if ( ! empty( $_POST[ $key ][ $menu_item_db_id ] ) ) {
					// Faites quelques vérifications ici....
					$value = $_POST[ $key ][ $menu_item_db_id ];
				} else {
					$value = 'show';
				}

				// Mise à jour
				if ( ! is_null( $value ) ) {
					update_post_meta( $menu_item_db_id, $key, $value );
				} else {
					delete_post_meta( $menu_item_db_id, $key );
				}
			}
		}

	    /**
	     * Champ wordpress
	     */
		public static function _fields( $id, $item, $depth, $args ) {
			global $wpdb;

			$wp_nav_menus = wp_get_nav_menus();
			$search_menu_id = [];
			foreach ($wp_nav_menus as $menu) {
				$get_nav_menus_items = wp_get_nav_menu_items($menu->term_id);
				foreach ($get_nav_menus_items as $get_nav_menu_item) {
					$search_menu_id[$get_nav_menu_item->ID] = $menu->term_id;
				}
			}
			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
			$wp_select = "SELECT * from ".$wp_table_app;
			$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

			if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
				$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
			}
			if(!empty($item->ID)){
				$ghl_menu_id = $search_menu_id[$item->ID];
			}
			foreach ( self::$fields as $_key => $label ) :
				$key   = sprintf( 'menu-item-%s', $_key );
				$id    = sprintf( 'edit-%s-%s', $key, $item->ID );
				$name  = sprintf( '%s[%s]', $key, $item->ID );
				$value = get_post_meta( $item->ID, $key, true );
				$class = sprintf( 'field-%s', $_key );
				$type  = $label['type'];
				if($type == 'checkbox'){
					$checked = '';
					if($value == $label['value']){
						$checked = 'checked="checked"';
					}
					if($_key == 'ghostlink'){
						if(empty($value)){
							if(isset($wp_setting['general_setting']['obfuscation']['menu'][$ghl_menu_id]) AND $wp_setting['general_setting']['obfuscation']['menu'][$ghl_menu_id] == 'on'){
								$checked = 'checked="checked"';
							}
						}
					}
					$tpl_type = '<label for="'.$id.'"><input type="'.$type.'" id="'.$id.'" class="widefat '.$id.'" name="'.$name.'" value="'.$label['value'].'" '.$checked.' />'.$label['name'].'</label>';
				}
				if($type == 'select'){
					$link_default = '';
					$link_show = '';
					$link_hidden = '';
					if(!empty($value)){
						switch ($value) {
							case 'link_show':
								$link_show = ' selected="selected"';
							break;
							case 'link_hidden':
								$link_hidden = ' selected="selected"';
							break;
							default:
								$link_default = ' selected="selected"';
							break;
						}
					}
					$tpl_type = '<label for="'.$id.'">Ghostlink <br /> <select id="'.$id.'" name="'.$name.'"><option value="link_default"'.$link_default.'>'.__( 'Use the default ghostlink settings' , 'app_ghostlink' ).'</option><option value="link_show"'.$link_show.'>'.__( 'Leave the menu visible' , 'app_ghostlink' ).'</option><option value="link_hidden"'.$link_hidden.'>'.__( 'Obfuscate the menu' , 'app_ghostlink' ).'</option></select></label>';
				}
				if($type == 'text'){
					$tpl_type =  '<label for="'.$id.'">'.$label['name'].'<br /><input type="'.$type.'" id="'.$id.'" class="widefat '.$id.'" name="'.$name.'" value="'.$value.'"/></label>';
				}
				echo '<p class="description description-wide '.esc_attr( $class ).'">'.$tpl_type.'</p>';
			endforeach;
		}

	    /**
	     * Ajoute les champs aux options de l'écran wp
	     */
		public static function _columns( $columns ) {
			$columns = array_merge( $columns, self::$fields );
			return $columns;
		}
	}

	ghl_menu_custom_fields::init();