<?php
/**
 * Gestion des actions javascript POST WP
 */

 	/**
 	 * Auth : Identification du compte ghostlink
 	 */
 		function ghl_exec_auth_login(){
 			global $wpdb;
 			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;

 			if(empty($_POST['ghl_user'])){
 	            $return = [
 	                'error' => [
 						'name' => 'credentials_invalid',
 						'description' => __( 'Wrong email or password', 'app_ghostlink' )
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			if(empty($_POST['ghl_pwd'])){
 	            $return = [
 	                'error' => [
 						'name' => 'credentials_invalid',
 						'description' => __( 'Wrong email or password', 'app_ghostlink' )
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			$curl_data = [
 				"request_method" => "POST",
 				"url" => "/wp/user/auth/",
 				"auth" => "false",
 				"postfileds" => [
 					"json_encode" => true,
 					"data" => [
 						"user" => $_POST['ghl_user'],
 						"pwd" => $_POST['ghl_pwd'],
 					]
 				]
 			];
 			$curl = ghl_curl_request($curl_data);
 			if($curl['info']['http_code'] == 404){
 				if($curl['resp']['error']['name'] == 'credentials_invalid'){
 		            $return = [
 		                'error' => [
 							'name' => 'credentials_invalid',
 							'description' => __( 'Wrong email or password', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 			}
 			if($curl['info']['http_code'] == 200){
 				$wpdb->query( $wpdb->prepare( "UPDATE $wp_table_app SET oauth_tmp = %s WHERE id = %d", $curl['resp']['success']['user']['token'],1));
 				if($curl['resp']['success']['user']['authorization'] == 401){
 					$return = [
 		                'success' => [
 		                	'url' => admin_url( 'admin.php?page=ghl_auth_otp' ),
 		                    'request' => md5(ghl_fcnt_uuid())
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}else{
 					$return = [
 		                'success' => [
 		                	'url' => admin_url( 'admin.php?page=ghl_auth_wordpress' ),
 		                    'request' => md5(ghl_fcnt_uuid())
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 			}
 		}
 		add_action( 'wp_ajax_ghl_exec_auth_login', 'ghl_exec_auth_login' );

 	/**
 	 * Auth : Mot de passe perdu
 	 */
 		function ghl_exec_auth_forgot(){
 			global $wpdb;
 			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;

 			if(empty($_POST['ghl_user'])){
 	            $return = [
 	                'error' => [
 						'name' => 'email_invalid',
 						'description' => __( 'Email must be a valid email', 'app_ghostlink' )
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			$curl_data = [
 				"request_method" => "POST",
 				"url" => "/wp/user/forgot/",
 				"auth" => "false",
 				"postfileds" => [
 					"json_encode" => true,
 					"data" => [
 						"user" => $_POST['ghl_user']
 					]
 				]
 			];
 			$curl = ghl_curl_request($curl_data);
 			if($curl['info']['http_code'] == 404){
 				if($curl['resp']['error']['name'] == 'email_invalid'){
 		            $return = [
 		                'error' => [
 							'name' => 'email_invalid',
 							'description' => __( 'Email must be a valid email', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 			}
 			if($curl['info']['http_code'] == 200){
 				$return_data =  $curl['resp']['success'];
 		    	$oauth = $return_data['user']['token'];
 				$wpdb->query( $wpdb->prepare( "UPDATE $wp_table_app SET oauth_tmp = %s WHERE id = %d", $oauth,1));
 				$return = [
 	                'success' => [
 	                	'url' => admin_url( 'admin.php?page=ghl_auth_otp&control=password' ),
 	                    'request' => md5(ghl_fcnt_uuid())
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 		}
 		add_action( 'wp_ajax_ghl_exec_auth_forgot', 'ghl_exec_auth_forgot' );

 	/**
 	 * Auth : Création d'un compte ghostlink
 	 */
 		function ghl_exec_auth_register(){
 			global $wpdb;
 			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;

 			if(empty($_POST['ghl_pwd'])){
 	            $return = [
 	                'error' => [
 						'name' => 'pwd_invalid',
 						'description' => __( 'Password is a required field', 'app_ghostlink' )
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			if($_POST['ghl_pwd'] != $_POST['ghl_repwd']){
 	            $return = [
 	                'error' => [
 						'name' => 'pwd_invalid',
 						'description' => __( 'Password and confirmation must match', 'app_ghostlink' )
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			if(empty($_POST['ghl_user'])){
 	            $return = [
 	                'error' => [
 						'name' => 'email_invalid',
 						'description' => __( 'Email must be a valid email', 'app_ghostlink' )
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			$curl_data = [
 				"request_method" => "POST",
 				"url" => "/wp/user/register/",
 				"auth" => "false",
 				"postfileds" => [
 					"json_encode" => true,
 					"data" => [
 						"user" => $_POST['ghl_user'],
 						"pwd" => $_POST['ghl_pwd'],
 						"repwd" => $_POST['ghl_repwd']
 					]
 				]
 			];
 			$curl = ghl_curl_request($curl_data);
 			if($curl['info']['http_code'] == 404){
 				if($curl['resp']['error']['name'] == 'email_invalid'){
                         $return = [
                              'error' => [
                                   'name' => 'email_invalid',
                                   'description' => __( 'Email must be a valid email', 'app_ghostlink' )
                              ]
                         ];
 					echo json_encode($return);
 					die();
 				}
 				if($curl['resp']['error']['name'] == 'pwd_invalid'){
                         $return = [
                              'error' => [
                                   'name' => 'pwd_invalid',
                                   'description' => __( 'Password and confirmation must match', 'app_ghostlink' )
                              ]
                         ];
 					echo json_encode($return);
 					die();
 				}
 				if($curl['resp']['error']['name'] == 'user_used'){
                         $return = [
                              'error' => [
                                   'name' => 'user_used',
                                   'description' => __( 'An account already exists with this email address', 'app_ghostlink' )
                              ]
                         ];
 					echo json_encode($return);
 					die();
 				}
 			}
 			if($curl['info']['http_code'] == 200){
 				$return_data =  $curl['resp']['success'];
 		    	     $oauth = $return_data['user']['token'];
 				$wpdb->query( $wpdb->prepare( "UPDATE $wp_table_app SET oauth_tmp = %s WHERE id = %d", $oauth,1));
 				if($return_data['user']['authorization'] == 401){
                         $return = [
                              'success' => [
                                   'url' => admin_url( 'admin.php?page=ghl_auth_otp' ),
                                   'request' => md5(ghl_fcnt_uuid())
                              ]
                         ];
 					echo json_encode($return);
 					die();
 				}else{
                         $return = [
                              'success' => [
                                   'url' => admin_url( 'admin.php?page=ghl_auth_wordpress' ),
                                   'request' => md5(ghl_fcnt_uuid())
                              ]
                         ];
                         echo json_encode($return);
                         die();
 				}
 			}
 		}
 		add_action( 'wp_ajax_ghl_exec_auth_register', 'ghl_exec_auth_register' );

 	/**
 	 * Auth : Code OTP - Vérification email
 	 */
 		function ghl_exec_auth_otp_email(){
 			if(is_null($_POST['ghl_otp_1']) or is_null($_POST['ghl_otp_2']) or is_null($_POST['ghl_otp_3']) or is_null($_POST['ghl_otp_4'])){
 	            $return = [
 	                'error' => [
 						'name' => 'code_otp_invalid',
 						'description' => __( 'Wrong verification code', 'app_ghostlink' )
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			$curl_data = [
 				"request_method" => "POST",
 				"url" => "/wp/user/email/otp/",
 				"auth" => "tmp",
 				"postfileds" => [
 					"json_encode" => true,
 					"data" => [
 						"code_otp" => $_POST['ghl_otp_1'].''.$_POST['ghl_otp_2'].''.$_POST['ghl_otp_3'].''.$_POST['ghl_otp_4']
 					]
 				]
 			];
 			$curl = ghl_curl_request($curl_data);
 			if($curl['info']['http_code'] == 404){
 				if($curl['resp']['error']['name'] == 'code_otp_invalid'){
 		            $return = [
 		                'error' => [
 							'name' => 'code_otp_invalid',
 							'description' => __( 'Wrong verification code', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 			}
 			if($curl['info']['http_code'] == 401){
 	            $return = [
 	                'error' => [
 	                	'url' => admin_url( 'admin.php?page=ghl_auth_login' ),
                     	'request' => md5(ghl_fcnt_uuid())
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 			if($curl['info']['http_code'] == 200){
 				$return = [
 	                'success' => [
 	                	'url' => admin_url( 'admin.php?page=ghl_auth_wordpress' ),
 	                    'request' => md5(ghl_fcnt_uuid())
 	                ]
 	            ];
 				echo json_encode($return);
 				die();
 			}
 		}
 		add_action( 'wp_ajax_ghl_exec_auth_otp_email', 'ghl_exec_auth_otp_email' );

 	/**
 	 * Auth : Code OTP - Changement du mot de passe
 	 */
 		function ghl_exec_auth_otp_password(){
 			global $wpdb;
 			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;

 			if($_POST['request'] == 'change_password'){
 				if(empty($_POST['ghl_pwd'])){
 		            $return = [
 		                'error' => [
 							'name' => 'pwd_invalid',
 							'description' => __( 'Password is a required field', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 				if($_POST['ghl_pwd'] != $_POST['ghl_repwd']){
 		            $return = [
 		                'error' => [
 							'name' => 'pwd_invalid',
 							'description' => __( 'Password and confirmation must match', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 				if($_POST['code_otp']){
 		            $return = [
 		                'error' => [
 		                	'url' => admin_url( 'admin.php?page=ghl_auth_forgot' ),
 	                    	'request' => md5(ghl_fcnt_uuid())
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 				$code_otp = $_POST['ghl_otp'];
 				$curl_postfileds = [
 					"code_otp" => $_POST['ghl_otp'],
 					"pwd_new" => $_POST['ghl_pwd'],
 					"request" => "change_password"
 				];
 			}else{
 				if(is_null($_POST['ghl_otp_1']) or is_null($_POST['ghl_otp_2']) or is_null($_POST['ghl_otp_3']) or is_null($_POST['ghl_otp_4'])){
 		            $return = [
 		                'error' => [
 							'name' => 'code_otp_invalid',
 							'description' => __( 'Wrong verification code', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 				$curl_postfileds = [
 					"code_otp" => $_POST['ghl_otp_1'].''.$_POST['ghl_otp_2'].''.$_POST['ghl_otp_3'].''.$_POST['ghl_otp_4']
 				];
 			}
 			$curl_data = [
 				"request_method" => "POST",
 				"url" => "/wp/user/password/otp/",
 				"auth" => "tmp",
 				"postfileds" => [
 					"json_encode" => true,
 					"data" => $curl_postfileds
 				]
 			];
 			$curl = ghl_curl_request($curl_data);
 			if($curl['info']['http_code'] == 404){
 				if($curl['resp']['error']['name'] == 'code_otp_invalid'){
 		            $return = [
 		                'error' => [
 							'name' => 'code_otp_invalid',
 							'description' => __( 'Wrong verification code', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 				if($curl['resp']['error']['name'] == 'pwd_invalid'){
 		            $return = [
 		                'error' => [
 							'name' => 'pwd_invalid',
 							'description' => __( 'Password and confirmation must match', 'app_ghostlink' )
 		                ]
 		            ];
 					echo json_encode($return);
 					die();
 				}
 			}
 			if($curl['info']['http_code'] == 200){
 				$return_data =  $curl['resp']['success'];
 				if($_POST['request'] == 'change_password'){
 					$wpdb->query( $wpdb->prepare( "UPDATE $wp_table_app SET oauth_tmp = null WHERE id = %d", 1));
 					$return = [
 		                'success' => [
 		                	'url' => admin_url( 'admin.php?page=ghl_auth_login' ),
 		                    'request' => md5(ghl_fcnt_uuid())
 		                ]
 		            ];
 		        }else{
 					$return = [
 		                'success' => [
 		                	'code_otp' => $return_data['code_otp'],
 		                    'request' => md5(ghl_fcnt_uuid())
 		                ]
 		            ];
 		        }
 				echo json_encode($return);
 				die();
 			}
 		}
 		add_action( 'wp_ajax_ghl_exec_auth_otp_password', 'ghl_exec_auth_otp_password' );

     /**
	 * Récupération de l'abonnement de l'utilisateur
	 */
		function ghl_exec_user_subscription(){
               global $wpdb;
               $wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
               $wp_select = "SELECT * from ".$wp_table_app;
               $ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

			$curl_data = [
				"request_method" => "GET",
				"url" => "/wp/user/subscription/",
				"auth" => "true",
				"postfileds" => [
					"json_encode" => true,
					"data" => null
				]
			];
			$curl = ghl_curl_request($curl_data);
			if(isset($curl['err']) AND !empty($curl['err'])){
				$return = [
					'error' => [
						'name' => 'browser_refresh',
						'description' => 'Browser refresh needed'
					]
				];
				echo json_encode($return);
				die();
			} else {
				if($curl['info']['http_code'] != 200){
					$return = [
						'error' => [
							'name' => 'browser_refresh',
							'description' => 'Browser refresh needed'
						]
					];
					echo json_encode($return);
					die();
				}else{
                         if(isset($curl['resp']['success']['managed']) AND $curl['resp']['success']['managed'] == 'r4w'){
                              $sub_ghl = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_r4w.tpl");
                              $sub_ghl->set("ghl_r4w_link_manage_account", admin_url( 'admin.php?page=r4w_account&tab=account' ));
                              $subscription = [
                                   'box' => $sub_ghl->output()
                              ];
                         }else{
     					$class_credit_applied = '';
     					$tpl_sub_reduction = '';
     					$nbr_card = __('No cards added','app_ghostlink');
     					if(!empty($curl['resp']['success']['subscription'])){
     						if($curl['resp']['success']['subscription']['cancel']){
     							$sub_cancelsub = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_cancelsub.tpl");
     							$sub_cancelsub->set("subscription_text", sprintf(__('Your subscription will be canceled on %s, after this date you will no longer have access to the benefit of your subscription','app_ghostlink'), '<b>'.ghl_date_format_timezone($curl['resp']['success']['subscription']['date']).'</b>'));
     							$sub_cancelsub->set("sub_reduction",$tpl_sub_reduction);
     							$tpl_sub_reduction = $sub_cancelsub->output();
     						}else{
     							$tpl_inc = false;
     							if($curl['resp']['success']['subscription']['status'] == 'trialing'){
     								$sub_trialing = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_trialing.tpl");
     								$amount = $curl['resp']['success']['subscription']['amount'];
     								$tpl_sub_reduction = $sub_trialing->output();
     								$tpl_inc = true;
     							}

     							if($curl['resp']['success']['subscription']['status'] == 'past_due'){
     								$sub_issue = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_issue.tpl");
     								$sub_issue->set("issue_msg", sprintf(__('A problem occurred during the payment of your last invoice for an amount of %s, we will represent the payment on %s, remember to update your credit card','app_ghostlink'), ghl_price_currency($curl['resp']['success']['subscription']['currency'],$curl['resp']['success']['subscription']['issue']['total']), '<b>'.ghl_date_format_timezone($curl['resp']['success']['subscription']['issue']['next_payment_attempt']).'</b>'));
     								$amount = $curl['resp']['success']['subscription']['amount'];
     								$tpl_sub_issue = $sub_issue->output();
     								$tpl_inc = true;
     							}
     							if($curl['resp']['success']['account']['card']){
     								$sub_card = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_card.tpl");
     								$sub_card->set("card_logo", ghl_assets_svg_code('card_'.strtolower($curl['resp']['success']['account']['card']['name'])));
     								$sub_card->set("card_last_card", $curl['resp']['success']['account']['card']['last_card']);
     								$sub_card->set("card_expiration_date", $curl['resp']['success']['account']['card']['expiration_date']);
     								$nbr_card = $sub_card->output();
     							}

     							if(!empty($curl['resp']['success']['account']['discount'])){
     								$sub_reduction = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_reduction.tpl");
     								if($curl['resp']['success']['account']['discount'] >= 99){
     									$class_credit_applied = ' class="credit_applied" ';
     									$sub_reduction->set("discount_msg", sprintf(__( 'Your %s discount will be used to pay your next bill', 'app_ghostlink' ), $curl['resp']['success']['account']['discount'].'%'));
     									$amount = $curl['resp']['success']['subscription']['amount'];
     								}else{
     									$sub_reduction->set("discount_msg", sprintf(__( 'Your %s discount will be applied to your next bill', 'app_ghostlink' ), $curl['resp']['success']['account']['discount'].'%'));
     									$amount = $curl['resp']['success']['subscription']['amount_discount'];
     								}
     								$tpl_sub_reduction = $sub_reduction->output();
     								$tpl_inc = true;
     							}

     							if(!$tpl_inc){
     								if($curl['resp']['success']['account']['balance']){
     									$sub_balance = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_balance.tpl");
     									$tpl_sub_balance = $sub_balance->output();
     								}
     								$amount = $curl['resp']['success']['subscription']['amount'];
     							}
     							$price = '<b'.$class_credit_applied.'>'.ghl_price_currency($curl['resp']['success']['subscription']['currency'],$amount).'</b>';

     							$sub_subscribes = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_subscribes.tpl");
     							$sub_subscribes->set("card", $nbr_card);
     							$sub_subscribes->set("url_subscription", admin_url( 'admin.php?page=ghl_subscription' ));
     							$sub_subscribes->set("sub_date_d", date('d',$curl['resp']['success']['subscription']['date']));
     							$sub_subscribes->set("sub_date_my", ghl_f_months(date('F',$curl['resp']['success']['subscription']['date'])).' '.date('Y',$curl['resp']['success']['subscription']['date']));
     							$sub_subscribes->set("subscription_text", sprintf(__('Your next bill will be %s. It will be taken on %s','app_ghostlink'), $price,'<b>'.ghl_date_format_timezone($curl['resp']['success']['subscription']['date']).'</b>'));
     							$sub_subscribes->set("sub_reduction",$tpl_sub_reduction);
     							$sub_subscribes->set("time_before_expiration", sprintf(__('The cancellation will be effective at the end of the current billing period, the %s','app_ghostlink'), '<b>'.ghl_date_format_timezone($curl['resp']['success']['subscription']['date']).'</b>'));
     							$tpl_sub_reduction = $sub_subscribes->output();
     						}
     					}else{
     						$sub_unsubscribed = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/sub_unsubscribed.tpl");
     						$sub_unsubscribed->set("url_subscription", admin_url( 'admin.php?page=ghl_subscription' ));
     						$tpl_sub_reduction = $sub_unsubscribed->output();
     					}
                              $subscription = [
                                   'box' => $tpl_sub_reduction,
                                   'issue' => $tpl_sub_issue,
                              ];
                         }
					$return = [
						'success' => [
							'subscription' => $subscription,
							'request' => md5(ghl_fcnt_uuid())
						]
					];
					echo json_encode($return);
					die();
				}
			}
		}
		add_action( 'wp_ajax_ghl_exec_user_subscription', 'ghl_exec_user_subscription' );

     /**
	 *  Liste des wordpress de l'utilisateur
	 */
		function ghl_exec_user_wordpress(){
               global $wpdb;
               $wp_table_app = $wpdb->prefix.ghl_bdd_table_app;

               $wp_select = "SELECT * from ".$wp_table_app;
               $ghl_app = $wpdb->get_row($wp_select,ARRAY_A);
               if(isset($_POST['ghl_method'])){
                    switch ($_POST['ghl_method']) {
                         case 'remove_linked':
                         	$curl_data = [
                         		"request_method" => "DELETE",
                         		"auth" => "true",
                         		"url" => "/wp/user/wordpress/".$_POST['ghl_uuid'],
                         		"postfileds" => [
                         			"json_encode" => true,
                         			"data" => [
                         				"action" => $_POST['ghl_method']
                         			]
                         		]
                         	];
                         	$curl = ghl_curl_request($curl_data);
                         break;
                         case 'remove_wordpress':
                         	$curl_data = [
                         		"request_method" => "DELETE",
                         		"auth" => "true",
                         		"url" => "/wp/user/wordpress/".$_POST['ghl_uuid'],
                         		"postfileds" => [
                         			"json_encode" => true,
                         			"data" => [
                         				"action" => $_POST['ghl_method']
                         			]
                         		]
                         	];
                         	$curl = ghl_curl_request($curl_data);
                         break;
                         case 'remove_subscription':
                         	$curl_data = [
                         		"request_method" => "DELETE",
                         		"auth" => "true",
                         		"url" => "/wp/user/wordpress/".$_POST['ghl_uuid'],
                         		"postfileds" => [
                         			"json_encode" => true,
                         			"data" => [
                         				"action" => $_POST['ghl_method']
                         			]
                         		]
                         	];
                         	$curl = ghl_curl_request($curl_data);
                         break;
                         case 'add_subscription':
                         	$curl_data = [
                         		"request_method" => "PUT",
                         		"auth" => "true",
                         		"url" => "/wp/user/wordpress/".$_POST['ghl_uuid'],
                         		"postfileds" => [
                         			"json_encode" => true,
                         			"data" => [
                         				"action" => $_POST['ghl_method']
                         			]
                         		]
                         	];
                         	$curl = ghl_curl_request($curl_data);
                         break;
                         case 'reassociate_subscription':
                         	$curl_data = [
                         		"request_method" => "PUT",
                         		"auth" => "true",
                         		"url" => "/wp/user/wordpress/".$_POST['ghl_uuid'],
                         		"postfileds" => [
                         			"json_encode" => true,
                         			"data" => [
                         				"action" => $_POST['ghl_method']
                         			]
                         		]
                         	];
                         	$curl = ghl_curl_request($curl_data);
                         break;
                    }
               }
               $curl_data = [
               	"request_method" => "GET",
               	"auth" => "true",
               	"url" => "/wp/user/wordpress",
               	"postfileds" => [
               		"json_encode" => true,
               		"data" => null
               	]
               ];
               $curl = ghl_curl_request($curl_data);
               if($curl['info']['http_code'] != 200){
               	$return = [
               		'error' => [
               			'name' => 'browser_refresh',
               			'description' => 'Browser refresh needed'
               		]
               	];
               	echo json_encode($return);
               	die();
               }else{
                    if(isset($curl['resp']['success']['managed']) AND $curl['resp']['success']['managed'] == 'r4w'){
                         $sub_ghl = new ghl_template(ghl_plugin_base."/tpl/account/tab_wordpress/sub_r4w.tpl");
                         $sub_ghl->set("ghl_r4w_link_manage_wordpress", admin_url( 'admin.php?page=r4w_account&tab=wordpress' ));
                         $subscription = [
                              'box' => $sub_ghl->output()
                         ];
                         $return = [
                              'success' => [
                                   'wordpress' => $sub_ghl->output(),
                                   'request' => md5(ghl_fcnt_uuid())
                              ]
                         ];
                         echo json_encode($return);
                         die();
                    }else{
                         if($curl['resp']['success']['list']){
                              if(empty($curl['resp']['success']['subscription'])){
                                   $sub_rm_wordpress = '<div id="ghl_sub_wordpress" class="css-5fd0fgevvre"><b>'.__( 'No subscription', 'app_ghostlink' ).'</b> </div>';
                                   $data_reamining = 'empty';
                              }else{
                                   if(!is_numeric($curl['resp']['success']['subscription']['available'])){
                                        $sub_rm_wordpress = '<div id="ghl_sub_wordpress" class="css-5fd0fgevvre"><b>'.__( 'Unlimited Wordpress', 'app_ghostlink' ).'</b> </div>';
                                        $data_reamining = 'true';
                                   }else{
                                        $sub_rm_wordpress = '<div id="ghl_sub_wordpress" class="css-5fd0fgevvre">'.__( 'Subscription available', 'app_ghostlink').' : <b>'.$curl['resp']['success']['subscription']['available'].'/'.$curl['resp']['success']['subscription']['total'].'</b> </div>';
                                        if($curl['resp']['success']['subscription']['available'] >=1){
                                             $data_reamining = 'true';
                                        }else{
                                             $data_reamining = 'false';
                                        }
                                   }
                              }
                              $tpl_list_wordpress = '';
                              foreach ($curl['resp']['success']['list'] as $list_wordpress) {
                                   $list_wp_msg ='';
                                   $tpl_loop_wordpress = new ghl_template(ghl_plugin_base."/tpl/account/tab_wordpress/loop_wordpress.tpl");
                                   $tpl_loop_wordpress->set("wordpress_url",$list_wordpress['url']);

                                   /**
                                    * Wordpress : associé au compte (oui)
                                    */
                                   if($list_wordpress['sync_account']){
                                        $color_wp = 'ghl_wpsync_green';
                                        $ghl_menu_acc = '<a class="ghl_open_remove_linked" href="#">'.__( 'Remove the association from the account','app_ghostlink' ).'</a>';
                                   }

                                   /**
                                    * Wordpress : associé au compte (non)
                                    */
                                   if(!$list_wordpress['sync_account']){
                                        $color_wp = 'ghl_wpsync_red';
                                        $ghl_menu_acc = '<a class="ghl_open_remove_wordpress" href="#">'.__( 'Delete from account','app_ghostlink' ).'</a>';
                                   }

                                   /**
                                    * Wordpress : associé à l'abonnement (non)
                                    */
                                   if($list_wordpress['sync_subscription'] == false){
                                        $color_sub = 'ghl_wpsync_red';
                                        $ghl_menu_sub = '<a class="ghl_open_add_subscription" href="#">'.__( 'Add to your subscription','app_ghostlink' ).'</a>';
                                   }

                                   /**
                                    * Wordpress : associé à l'abonnement (oui)
                                    */
                                   if($list_wordpress['sync_subscription'] == true){
                                        $color_sub = 'ghl_wpsync_green';
                                        $ghl_menu_sub = '<a class="ghl_remove_subscription" href="#">'.__( 'Remove from your subscription','app_ghostlink' ).'</a>';
                                   }

                                   /**
                                    * Wordpress : associé au compte (non) | associé à l'abonnement (oui)
                                    */
                                   if($list_wordpress['sync_account'] == false AND $list_wordpress['sync_subscription'] == true){
                                        $color_sub = 'ghl_wpsync_grey';
                                        $ghl_menu_acc = '';
                                        $list_wp_msg = '<div class="css-s5d0f0e5fe">'.__('This wordpress must be associated with your account to benefit from your subscription', 'app_ghostlink').'</div>';
                                   }

                                   /**
                                    * Wordpress : supprime de l'abonnement (oui) | associé au compte (non) | associé à l'abonnement (oui)
                                    */
                                   if($list_wordpress['sub_cancel'] == true AND $list_wordpress['sync_account'] == false AND  $list_wordpress['sync_subscription'] == true){
                                        $ghl_menu_acc = '';
                                   }

                                   /**
                                    * Wordpress: supprime de l'abonnement (oui) | associé à l'abonnement (oui)
                                    */
                                   if($list_wordpress['sub_cancel'] == true AND $list_wordpress['sync_subscription'] == true){
                                        $color_sub = 'ghl_wpsync_orange';
                                        $ghl_menu_sub = '<a class="ghl_reassociate" href="#">'.__( 'Re-add to your subscription','app_ghostlink' ).'</a>';
                                        $list_wp_msg = '<div class="css-s5d0f0e5fe ghl_wpbar_orange">'.__('On your next bill, this wordpress will no longer be associated with your subscription', 'app_ghostlink').'</div>';
                                   }

                                   /**
                                    * S'il s'agit de ce wordpress
                                    */
                                   if($list_wordpress['current'] == true){
                                        $ghl_menu_acc = '';
                                        $tpl_loop_wordpress->set("this_wordpress_txt", '<div class="css-5f0df5dsfve">'.__('You are on this wordpress', 'app_ghostlink').'</div>');
                                        $tpl_loop_wordpress->set("this_wordpress_ico",'<div class="ghl_star">'.ghl_assets_svg_code('star').'</div>');
                                   }else{
                                        $tpl_loop_wordpress->set("this_wordpress_txt", '');
                                        $tpl_loop_wordpress->set("this_wordpress_ico", '');
                                   }

                                   $show_menu =  $ghl_menu_acc.$ghl_menu_sub;

                                   $tpl_loop_wordpress->set("remaining_subscription",$data_reamining);
                                   $tpl_loop_wordpress->set("user_wp_uuid",$list_wordpress['uuid']);
                                   $tpl_loop_wordpress->set("show_menu",$show_menu);
                                   $tpl_loop_wordpress->set("color_wp",$color_wp);
                                   $tpl_loop_wordpress->set("list_wp_msg", $list_wp_msg);
                                   $tpl_loop_wordpress->set("color_sub",$color_sub);
                                   $tpl_list_wordpress .= $tpl_loop_wordpress->output();
                              }

                              $return = [
                               'success' => [
                                   'wordpress' => $sub_rm_wordpress.$tpl_list_wordpress,
                                   'request' => md5(ghl_fcnt_uuid())
                               ]
                           ];
                              echo json_encode($return);
                              die();
                         }else{
                              $return = [
                                   'success' => [
                                        'wordpress' => '<div id="box_empty_data"><div>'.ghl_assets_svg_code('empty_data').'</div><div class="css-sdf5sq0fe">'.__('Sorry, no wordpress available','app_ghostlink').'</div><div class="css-s5dz0f5ere">'.__('when you connect to a wordpress it will appear in this list','app_ghostlink').'</div></div>',
                                        'request' => md5(ghl_fcnt_uuid())
                                   ]
                              ];
                              echo json_encode($return);
                              die();
                         }
               	}
               }
		}
		add_action( 'wp_ajax_ghl_exec_user_wordpress', 'ghl_exec_user_wordpress' );


     /**
	 * Récupération des informations de l'utilisateur
	 */
		function ghl_exec_account(){
			if(!empty($_POST['ghl_method'])){
				switch ($_POST['ghl_method']) {
					case 'ghl_account_update':
						parse_str(urldecode($_POST['ghl_data']), $ghl_account_updates);
						foreach ($ghl_account_updates as $ghl_account_update => $ghl_account_value) {

						    $ghl_update_keys = explode('|', $ghl_account_update);
				 			$array ='$ghl_return_acc';
							foreach($ghl_update_keys as $ghl_update_key){
							    $array.="['$ghl_update_key']";
							}
							$array.= '=$ghl_account_value;';
							eval($array);
						}
						$curl_data = [
							"request_method" => "PUT",
							"url" => "/wp/account/",
							"auth" => "true",
							"postfileds" => [
								"json_encode" => true,
								"data" => [
									"user_data" => $ghl_return_acc
								]
							]
						];
						$curl = ghl_curl_request($curl_data);
						$return = [
			                'success' => [
			                    'request' => md5(ghl_fcnt_uuid())
			                ]
			            ];
						echo json_encode($return);
						die();
					break;
				}
			}else{
				$curl_data = [
					"request_method" => "GET",
					"url" => "/wp/account/",
					"auth" => "true",
					"postfileds" => [
						"json_encode" => true,
						"data" => null
					]
				];
				$curl = ghl_curl_request($curl_data);

				$acc_email = ghl_assets_svg_code('dash_no_data');
				$acc_firstname = ghl_assets_svg_code('dash_no_data');
				$acc_lastname = ghl_assets_svg_code('dash_no_data');
				$preview_detail = '';
				$account = '';
				if(isset($curl['resp']['success'])){
					$account = $curl['resp']['success']['account'];
					if(isset($curl['resp']['success']['account']['type'])){
						$acc_type = $curl['resp']['success']['account']['type'];
					}
					if(isset($curl['resp']['success']['account']['email'])){
						$acc_email = $curl['resp']['success']['account']['email'];
					}
					if(isset($curl['resp']['success']['account']['individual']['firstname'])){
						$acc_firstname = $curl['resp']['success']['account']['individual']['firstname'];
					}
					if(isset($curl['resp']['success']['account']['individual']['lastname'])){
						$acc_lastname = $curl['resp']['success']['account']['individual']['lastname'];
					}
					if(isset($curl['resp']['success']['account']['professional']['company'])){
						$acc_company = $curl['resp']['success']['account']['professional']['company'];
					}

					if(empty($acc_type)){
						$preview_detail = ' <div><b>'.__('First name', 'app_ghostlink').' :</b> '.$acc_firstname.'</div> <div><b>'.__('Last name','app_ghostlink').' : </b>'.$acc_lastname.'</div>';
					}else{
						if($acc_type == 'individual'){
							$preview_detail = ' <div><b>'.__('First name', 'app_ghostlink').' :</b> '.$acc_firstname.'</div> <div><b>'.__('Last name','app_ghostlink').' :</b> '.$acc_lastname.'</div>';
						}
						if($acc_type == 'professional'){
							$preview_detail = ' <div><b>'.__('Company Name', 'app_ghostlink').' :</b> '.$acc_company.'</div>';
						}
					}
				}
				$preview = '<div><b>'.__('E-mail', 'app_ghostlink').' : </b>'.$acc_email.'</div>'.$preview_detail;
				$return = [
                         'success' => [
                              'account' => $account,
                              'preview' => $preview,
                              'request' => md5(ghl_fcnt_uuid())
                         ]
	               ];
				echo json_encode($return);
				die();
			}
		}
		add_action( 'wp_ajax_ghl_exec_account', 'ghl_exec_account' );

     /**
	 * Récupération du produit
	 */
		function ghl_exec_products(){
			global $wpdb;
			$curl_data = [
				"request_method" => "GET",
				"url" => "/wp/account/",
				"auth" => "true",
				"postfileds" => [
					"json_encode" => true,
					"data" => null
				]
			];
			$curl_account = ghl_curl_request($curl_data);
			if(isset($curl_account['err']) AND !empty($curl_account['err'])){
				$return = [
					'error' => [
						'name' => 'browser_refresh',
						'description' => 'Browser refresh needed'
					]
				];
				echo json_encode($return);
				die();
			} else {
				if($curl_account['info']['http_code'] != 200){
					$return = [
						'error' => [
							'name' => 'browser_refresh',
							'description' => 'Browser refresh needed'
						]
					];
					echo json_encode($return);
					die();
				}else{
					if($curl_account['resp']['success']['account']['subscription']){
						$already_subscribed = new ghl_template(ghl_plugin_base."/tpl/subscription/already_subscribed.tpl");
						$already_subscribed->set("url_another_account", admin_url( 'admin.php?page=ghl_auth_login' ));
						$already_subscribed->set("url_manage_subscription", admin_url( 'admin.php?page=ghl_account' ));
						$already_subscribed->set("we_love", sprintf(__( 'We love you too much for taking your hard earned money twice. The user %s already has a ghostlink subscription', 'app_ghostlink' ), $curl_account['resp']['success']['account']['email']) );
						$tpl_already_subscribed = $already_subscribed->output();
                              $return = [
                                   'success' => [
                                        'preview' => $tpl_already_subscribed,
                                        'request' => md5(ghl_fcnt_uuid())
                                   ]
                              ];
						echo json_encode($return);
						die();
					}else{
						$product_uuid = '';
						if(!empty($_POST['product_uuid'])){
							$product_uuid = $_POST['product_uuid'];
						}
						if(!empty($_POST['product_unit'])){
							$product_unit = [ "unit" => $_POST['product_unit'] ];
						}else{
							$product_unit = null;
						}
						$curl_data = [
							"request_method" => "GET",
							"url" => "/wp/products/".$product_uuid,
							"auth" => "true",
							"postfileds" => [
								"json_encode" => true,
								"data" => $product_unit
							]
						];
						$curl = ghl_curl_request($curl_data);
						if(isset($curl['err']) AND !empty($curl['err'])){
							$return = [
								'error' => [
									'name' => 'browser_refresh',
									'description' => 'Browser refresh needed'
								]
							];
							echo json_encode($return);
							die();
						} else {
							if($curl['info']['http_code'] != 200){
								$return = [
									'error' => [
										'name' => 'browser_refresh',
										'description' => 'Browser refresh needed'
									]
								];
								echo json_encode($return);
								die();
							}else{
								if(!empty($curl['resp']['success']['products'])){
									switch ($_POST['method']) {
										case 'product':
											$tpl_subscriptions = '';
											foreach ($curl['resp']['success']['products'] as $products) {
												$svg_data_true = '<div class="css-sf5e0tgre4y check"><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 426.667 426.667" xml:space="preserve"><path d="M213.333,0C95.518,0,0,95.514,0,213.333s95.518,213.333,213.333,213.333 c117.828,0,213.333-95.514,213.333-213.333S331.157,0,213.333,0z M174.199,322.918l-93.935-93.931l31.309-31.309l62.626,62.622 l140.894-140.898l31.309,31.309L174.199,322.918z"></path></svg></div>';
												$svg_data_false = '<div class="css-sf5e0tgre4y uncheck"><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 426.667 426.667" xml:space="preserve"><path d="M213.333,0C95.514,0,0,95.514,0,213.333s95.514,213.333,213.333,213.333 s213.333-95.514,213.333-213.333S331.153,0,213.333,0z M330.995,276.689l-54.302,54.306l-63.36-63.356l-63.36,63.36l-54.302-54.31 l63.356-63.356l-63.356-63.36l54.302-54.302l63.36,63.356l63.36-63.356l54.302,54.302l-63.356,63.36L330.995,276.689z"></path></svg> </div>';
												if(!empty($products['metadata']['data'])){
													$metadatas = json_decode($products['metadata']['data'],true);
													$tpl_loop_li = '';
													foreach ($metadatas as $data) {
														$svg_data_available = $svg_data_false;
														$title = '';
														if(!empty($data['availability'])){
															if($data['availability']){
																$svg_data_available = $svg_data_true;
															}
														}
														if(!empty($data['title'])){
															$title = $data['title'];
														}
														$tpl_loop_li .= '<li>'.$svg_data_available.' <div class="css-dfzre45z0">'.$title.'</div></li>';
													}
													$features = $tpl_loop_li;
												}else{
													$features = '';
												}
												if(!empty($product_uuid)){
													$loop_products = new ghl_template(ghl_plugin_base."/tpl/subscription/stripe_preview.tpl");
													$loop_products->set("amount", ghl_price_currency($products['currency'],$products['amount_ttc']));
								            	}else{
													$loop_products = new ghl_template(ghl_plugin_base."/tpl/subscription/loop_products.tpl");
													$tpl_products = new ghl_template(ghl_plugin_base."/tpl/subscription/products.tpl");
													$loop_products->set("amount", ghl_price_currency($products['currency'],$products['amount_ht']));
								            	}

									          switch ($products['metadata']['subscription_wordpress']) {
									        		case 'unlimited':
                                                                 $loop_products->set("choice_number", '<div>'.__( 'Number of WordPress', 'app_ghostlink' ).':</div><div class="css-sd50sd5e">'.__( 'Unlimited','app_ghostlink' ).'</div>');
									        			break;
									        		case 'limited':
                                                                 $loop_products->set("choice_number", '<div>'.__( 'Number of WordPress', 'app_ghostlink' ).':</div> <div class="number-input"> <button class="quantity_down"></button> <input class="quantity" min="1" max="300" name="product_unit" value="1" type="number"> <button class="plus quantity_up"></button> </div>');
									        		break;
									        	}
											$loop_products->set("name", $products['name']);
											$loop_products->set("features", $features);
											$loop_products->set("plan_uuid", $products['uuid']);
											switch ($products['interval']) {
													case 'month':
														$loop_products->set("sub_interval",  __( 'month', 'app_ghostlink' ));
														break;
													case 'year':
														$loop_products->set("sub_interval",  __( 'year', 'app_ghostlink' ));
														break;
												}
												$tpl_subscriptions .= $loop_products->output();
											}
											if(!empty($product_uuid)){
												$tpl_sub_prod = $loop_products->output();
									            $return = [
									                'success' => [
									                	'preview' => $tpl_sub_prod,
									                	'amount' => $curl['resp']['success']['products'][0]['amount_ttc'],
									                	'product' => $curl['resp']['success']['products'][0],
									                	'stripe' => $curl['resp']['success']['stripe'],
									                    'request' => md5(ghl_fcnt_uuid())
									                ]
									            ];
												echo json_encode($return);
												die();
											}else{
												$tpl_products->set("products", $tpl_subscriptions);
												$tpl_sub_prod = $tpl_products->output();
									            $return = [
									                'success' => [
									                	'preview' => $tpl_sub_prod,
									                    'request' => md5(ghl_fcnt_uuid())
									                ]
									            ];
												echo json_encode($return);
												die();
											}

											break;
									}
								}
							}
						}
					}
				}
			}
		}
		add_action( 'wp_ajax_ghl_exec_products', 'ghl_exec_products' );

     /**
	 *  Stripe : Paiement et validation de l'abonnement
	 */
		function ghl_exec_stripe(){
			global $wpdb;
			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;

		    $wp_select = "SELECT * from ".$wp_table_app;
		    $ghl_app = $wpdb->get_row($wp_select,ARRAY_A);
		    if(empty($_POST['product_unit'])){
		    	$product_unit = 1;
		    }else{
		    	$product_unit = $_POST['product_unit'];
		    }
		    if(!empty($_POST['product_type'])){
                    switch ($_POST['product_type']) {
                         case 'option':
                              $curl_data = [
     						"request_method" => "PUT",
     						"auth" => "true",
     						"url" => "/wp/stripe/option/".$_POST['option_uuid'],
     						"postfileds" => [
     							"json_encode" => true,
     							"data" => [
     								"option_unit" => $_POST['option_unit'],
     								"stripe_token" => $_POST['stripe_token']
     							]
     						]
     					];
     					$curl = ghl_curl_request($curl_data);
     					$success = [
     						'request' => md5(ghl_fcnt_uuid())
     					];
     			    	break;
     			    	case 'subscription':
                              if( $_POST['stripe_type'] == 'add'){
     						$curl_data = [
     							"request_method" => "PUT",
     							"auth" => "true",
     							"url" => "/wp/stripe/subscription/".$_POST['product_uuid'],
     							"postfileds" => [
     								"json_encode" => true,
     								"data" => [
     									"product_unit" => $product_unit,
     									"coupon" => $_POST['product_discount'],
     									"stripe_token" => $_POST['stripe_token']
     								]
     							]
     						];
     						$curl = ghl_curl_request($curl_data);
     						if(!isset($curl['resp']['error'])){
     							$success = [
     								'url' => admin_url( 'admin.php?page=ghl_account&tab=wordpress' ),
     								'request' => md5(ghl_fcnt_uuid())
     							];
     						}
     					}
     					if( $_POST['stripe_type'] == 'reactivate'){
     						$curl_data = [
     							"request_method" => "POST",
     							"auth" => "true",
     							"url" => "/wp/stripe/subscription/",
     							"postfileds" => [
     								"json_encode" => true,
     								"data" => [
     									"type" => "reactivate"
     								]
     							]
     						];
     						$curl = ghl_curl_request($curl_data);
     						if(!isset($curl['resp']['error'])){
     							$success = [
     								'url' => admin_url( 'admin.php?page=ghl_account' ),
     								'request' => md5(ghl_fcnt_uuid())
     							];
     						}
     					}
     					if( $_POST['stripe_type'] == 'canceled'){
     						$curl_data = [
     							"request_method" => "POST",
     							"auth" => "true",
     							"url" => "/wp/stripe/subscription/",
     							"postfileds" => [
     								"json_encode" => true,
     								"data" => [
     									"type" => "canceled",
     									"reason" => $_POST['reason']
     								]
     							]
     						];
     						$curl = ghl_curl_request($curl_data);
     						if(!isset($curl['resp']['error'])){
     							$success = [
     								'url' => admin_url( 'admin.php?page=ghl_account' ),
     								'request' => md5(ghl_fcnt_uuid())
     							];
     						}
     					}
     					if( $_POST['stripe_type'] == 'unpaid'){
     						$curl_data = [
     							"request_method" => "POST",
     							"auth" => "true",
     							"url" => "/wp/stripe/subscription/",
     							"postfileds" => [
     								"json_encode" => true,
     								"data" => [
     									"type" => "unpaid",
     									"reason" => $_POST['reason']
     								]
     							]
     						];
     						$curl = ghl_curl_request($curl_data);
     						if(!isset($curl['resp']['error'])){
     							$success = [
     								'url' => admin_url( 'admin.php?page=ghl_account' ),
     								'request' => md5(ghl_fcnt_uuid())
     							];
     						}
     					}
     					if( $_POST['stripe_type'] == 'discount'){
     						$curl_data = [
     							"request_method" => "POST",
     							"auth" => "true",
     							"url" => "/wp/stripe/subscription/",
     							"postfileds" => [
     								"json_encode" => true,
     								"data" => [
     									"type" => "discount",
     									"coupon" => $_POST['product_discount']
     								]
     							]
     						];
     						$curl = ghl_curl_request($curl_data);
     						if(!isset($curl['resp']['error'])){
     							$success = [
     								'msg' => '<div class="css-fd50e5fef">'.$curl['resp']['success']['discount']['name'].'</div>',
     								'code' => $curl['resp']['success']['discount']['code'],
     								'request' => md5(ghl_fcnt_uuid())
     							];
     						}
     					}
     			    	break;
     				case 'account':
     					if( $_POST['stripe_type'] == 'get_payment'){
     						$curl_data = [
     							"request_method" => "GET",
     							"auth" => "true",
     							"url" => "/wp/stripe/customer/",
     							"postfileds" => [
     								"json_encode" => true,
     								"data" => null
     							]
     						];
     						$curl = ghl_curl_request($curl_data);
     						if(!isset($curl['resp']['error'])){
     							$stripe_preview = new ghl_template(ghl_plugin_base."/tpl/account/tab_account/stripe_preview.tpl");
     							$return_stripe_preview = $stripe_preview->output();
     							$success = [
     								'preview' => $return_stripe_preview,
     								'stripe' => $curl['resp']['success']['stripe'],
     								'request' => md5(ghl_fcnt_uuid())
     							];
     						}
     					}
     					if( $_POST['stripe_type'] == 'update_payment'){
     						$curl_data = [
     							"request_method" => "PUT",
     							"auth" => "true",
     							"url" => "/wp/stripe/customer/",
     							"postfileds" => [
     								"json_encode" => true,
     								"data" => [
     									"stripe_token" => $_POST['stripe_token']
     								]
     							]
     						];
     						$curl = ghl_curl_request($curl_data);
     						if(!isset($curl['resp']['error'])){
     							$success = [
     								'url' => admin_url( 'admin.php?page=ghl_account' ),
     								'request' => md5(ghl_fcnt_uuid())
     							];
     						}
     					}
     				break;
			    }
			}
			if(!empty($curl)){
				if($curl['info']['http_code'] != 201){
					if($curl['resp']['error']['name'] == 'stripe_payment'){
						$return = [
							'error' => [
								'name' => 'stripe_payment',
								'description' => "Stripe payment did not succeed"
							]
						];
						echo json_encode($return);
						die();
					}
					if($curl['resp']['error']['name'] == 'stripe_coupon_invalid'){
						$return = [
							'success' =>  [
								'msg' => '<div class="css-sdg50e5fe">'.__('Invalid or expired coupon','app_ghostlink').'</div>',
								'request' => md5(ghl_fcnt_uuid())
							]
						];
						echo json_encode($return);
						die();
					}
					$return = [
						'error' => [
							'name' => 'browser_refresh',
							'description' => 'Browser refresh needed'
						]
					];
					echo json_encode($return);
					die();
				}else{
					if(isset($curl['resp']['success'])){
						$return = [
			                'success' => $success
			            ];
						echo json_encode($return);
						die();
					}
				}
			}
		}
		add_action( 'wp_ajax_ghl_exec_stripe', 'ghl_exec_stripe' );

	/**
	 * Decryptage du liens
	 */
		function ghl_exec_ghostbuster(){
			global $wpdb, $ghl_define;

			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
			$wp_select = "SELECT * from ".$wp_table_app;
			$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

			if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
				$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
			}

			if(empty($_POST['ghl_buster'])){
				die();
			}

			if( isset($wp_setting['general_setting']['encryption']['links']) and $wp_setting['general_setting']['encryption']['links'] == "on" ){
				$ghl_encodage = 'AES';
			}else{
				$ghl_encodage = 'B64';
			}
			$curl_data = [
				"request_method" => "POST",
				"url" => "/wp/buster/",
				"auth" => "false",
				"postfileds" => [
					"json_encode" => true,
					"data" => [
						"ghl_buster" => $_POST['ghl_buster'],
						"ghl_encodage" => $ghl_encodage
					]
				]
			];
			$curl = ghl_curl_request($curl_data);
			if($curl['info']['http_code'] != 200){
			}
			if($curl['info']['http_code'] == 200){
				$return = [
					'success' => [
						'url' => $curl['resp']['success']['url'],
						'request' => md5(ghl_fcnt_uuid())
					]
				];
				echo json_encode($return);
				die();
			}
		}
		add_action( 'wp_ajax_ghl_exec_ghostbuster', 'ghl_exec_ghostbuster' );
		add_action( 'wp_ajax_nopriv_ghl_exec_ghostbuster', 'ghl_exec_ghostbuster' );

	 /**
 	 * Enregistrement des paramètres du plugin
 	 */
 		function ghl_exec_settings(){
 			global $wpdb,$wp_rewrite;

 			if(!empty($_POST['ghl_document_id'])){
 				$post_id = $_POST['ghl_document_id'];
 			}
 			if(isset($_POST['ghl_keyword_type']) AND !empty($_POST['ghl_keyword_type'])){
 				$ghl_keyword_type = $_POST['ghl_keyword_type'];
 			}

 			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
			$wp_select = "SELECT * from ".$wp_table_app;
			$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

			if(!empty($ghl_app['settings'])){
				if(!is_null(hex2bin($ghl_app['settings']))){
					$ghl_settings =  json_decode(hex2bin($ghl_app['settings']),true);
				}else{
					$ghl_settings =  [];
				}
			}else{
				$ghl_settings = [];
			}

			$setting_update = $_POST['setting_update'];
			$setting_value = $_POST['setting_value'];

			$ghl_update_keys = explode('|', $setting_update);

  			$array ='$ghl_settings_update';
 			foreach($ghl_update_keys as $ghl_update_key){
 			    $array.="['$ghl_update_key']";
 			}
 			$array.= '=$setting_value;';
 			eval($array);

 			$ghl_new_settings = bin2hex(json_encode(array_replace_recursive($ghl_settings, $ghl_settings_update)));

			/**
			 * Enregistrement des données dans la table
			 */
			$wpdb->query( $wpdb->prepare( "UPDATE $wp_table_app SET settings = %s WHERE uuid = %s", $ghl_new_settings, $ghl_app['uuid']));
			$return = [
				'success' => [
					'request' => md5(ghl_fcnt_uuid())
				]
			];
			echo json_encode($return);
			die();
 		}
 		add_action( 'wp_ajax_ghl_exec_settings', 'ghl_exec_settings' );

     /**
	 * Effectue un pointage aurpès de api
	 */
		function ghl_exec_ping_system(){
			global $wpdb,$wp_version;

			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
		    $wp_select = "SELECT * from ".$wp_table_app;
		    $ghl_app = $wpdb->get_row($wp_select,ARRAY_A);
			$curl_data = [
				"request_method" => "GET",
				"url" => "/wp/ping/system/",
				"auth" => "true",
				"postfileds" => [
					"json_encode" => true,
					"data" => [
						"version_php" => phpversion(),
						"version_wp" => $wp_version,
						"version_ghl" => ghl_get_version()
					]
				]
			];
			$curl = ghl_curl_request($curl_data);
			if(isset($curl['err']) AND !empty($curl['err'])){
				$ping_msg = bin2hex(utf8_decode('<div class="ghl_msg_opr_maintenance"> <div class="css-fd5e0fe9fezr">'.ghl_assets_svg_code('question_info').'</div> <div class="css-df5e0fz5gz">'.__('The connection to the ghostlink server has been interrupted unexpectedly, some features may not work properly. Wait and try to refresh the page to fix the problem','app_ghostlink').'.</div> </div>'));
			} else {
				if($curl['info']['http_code'] == 404){
					if($curl['resp']['error']['name'] == 'wordpress_invalid'){
						$return = [
			                'success' => [
			                	'url' => admin_url( 'admin.php?page=ghl_wizard' ),
			                    'request' => md5(ghl_fcnt_uuid())
			                ]
			            ];
						echo json_encode($return);
						die();
					}
				}
				if($curl['info']['http_code'] == 401){
					if($curl['resp']['error']['name'] == 'bad_version'){
						$return = [
			                'success' => [
			                	'url' => admin_url( 'admin.php?page=ghl_update_available' ),
			                    'request' => md5(ghl_fcnt_uuid())
			                ]
			            ];
						echo json_encode($return);
						die();
					}
				}
				$good = false;
				if($curl['info']['http_code'] == 200){
					if(!empty($curl['resp']['success'])){
						if(!empty($curl['resp']['success']['downtime'])){
							foreach ($curl['resp']['success']['downtime'] as $downtime) {
								if($downtime == $_POST['ghl_tpl']){
									$ping_msg = bin2hex(utf8_decode('<div class="ghl_msg_opr_maintenance "> <div class="css-fd5e0fe9fezr">'.ghl_assets_svg_code('question_info').'</div> <div class="css-df5e0fz5gz">'.__('We make improvements on this service, do not be surprised if some features do not work properly during our intervention','app_ghostlink').'.</div> </div>'));
								}
							}
						}
						$good = true;
					}
				}
				if(!$good){
					$ping_msg = bin2hex(utf8_decode('<div class="ghl_msg_opr_maintenance "> <div class="css-fd5e0fe9fezr">'.ghl_assets_svg_code('question_info').'</div> <div class="css-df5e0fz5gz">'.__('The connection to the ghostlink server has been interrupted unexpectedly, some features may not work properly. Wait and try to refresh the page to fix the problem','app_ghostlink').'.</div> </div>'));
				}else{
					$ping_msg = null;
				}
			}
			$return = [
                'success' => [
                	'msg' => $ping_msg,
                    'request' => md5(ghl_fcnt_uuid())
                ]
            ];
			echo json_encode($return);
			die();
		}
		add_action( 'wp_ajax_ghl_exec_ping_system', 'ghl_exec_ping_system' );

	/**
	 * Recupération des factures
	 */
	function ghl_exec_user_invoice(){
		if(isset($_POST['ghl_method'])){
		    switch ($_POST['ghl_method']) {
			    case 'list_invoice':
				    $curl_data = [
						"request_method" => "GET",
						"auth" => "true",
						"url" => "/wp/user/invoice/",
						"postfileds" => [
							"json_encode" => true,
							"data" => [
								"action" => $_POST['ghl_method']
							]
						]
					];
					$curl = ghl_curl_request($curl_data);
					if(!empty($curl)){
						if($curl['info']['http_code'] != 200){
							$return = [
								'error' => [
									'name' => 'browser_refresh',
									'description' => 'Browser refresh needed'
								]
							];
							echo json_encode($return);
							die();
						}else{
							if(isset($curl['resp']['success'])){
								$tpl_list_wordpress = '';
								$tpl_list_invoice = null;
								foreach ($curl['resp']['success']['invoice'] as $list_invoice) {
									$list_wp_msg ='';
									$tpl_loop_invoice = new ghl_template(ghl_plugin_base."/tpl/account/tab_invoice/loop_invoice.tpl");
									$tpl_loop_invoice->set("invoice_uuid", $list_invoice['uuid']);
									if(!empty($list_invoice['date'])){
										$tpl_loop_invoice->set("invoice_date", date_i18n("d F Y",$list_invoice['date']));
									}else{
										$tpl_loop_invoice->set("invoice_date", ghl_assets_svg_code('dash_no_data'));
									}
									$tpl_loop_invoice->set("invoice_id", $list_invoice['id']);
									$tpl_loop_invoice->set("invoice_amount", number_format($list_invoice['amount']/100,2)."€");
									$tpl_list_invoice .= $tpl_loop_invoice->output();
								}
								$return = [
								 'success' => [
									 'invoices' => $tpl_list_invoice
								 ]
							  ];
								echo json_encode($return);
								die();
							}
						}
					}
				    break;
			    case 'pdf_invoice':
				    $curl_data = [
						"request_method" => "GET",
						"auth" => "true",
						"url" => "/wp/user/invoice/".$_POST['ghl_uuid'],
						"json_return" => false,
						"postfileds" => [
							"json_encode" => true,
							"data" => [
								"action" => $_POST['ghl_method']
							]
						]
					];
					$curl = ghl_curl_request($curl_data);
					$file_pdf_id = $_POST['ghl_invoice'];
				  	$target_dir = ghl_plugin_base.'/temp/';
					if (!file_exists($target_dir)) {
					    mkdir($target_dir, 0755, true);
					}
					if (file_put_contents($target_dir.'invoice_'.$file_pdf_id.'.pdf', $curl) !== false) {
						$file_create_pdf = true;
					}
					$return = [
					 'success' => [
						 'url' => admin_url( 'admin.php?page=ghl_download_invoice&invoice_id='.$file_pdf_id ),
						'request' => md5(ghl_fcnt_uuid())
					 ]
				  ];
					echo json_encode($return);
					die();
				    break;
		    }
		}
	}
	add_action( 'wp_ajax_ghl_exec_user_invoice', 'ghl_exec_user_invoice' );