<?php

/**
 * Walker personnalisé pour l'éditeur de menu de navigation
 * Nous séparons cette classe du fichier du plugin car Walker_Nav_Menu_Edit
 * n'est chargé que sur la page wp-admin/nav-menus.php.
 */
class ghl_walker extends Walker_Nav_Menu_Edit {
	/**
	* Lancez la sortie de l'élément.
	* Nous injectons nos champs personnalisés après la div.submitbox
	*/
	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
		$item_output = '';
		parent::start_el( $item_output, $item, $depth, $args, $id );
		$output .= preg_replace(
			// NOTE: Vérifiez ce regex de temps en temps !
			'/(?=<(fieldset|p)[^>]+class="[^"]*field-move)/',
			$this->get_fields( $item, $depth, $args),
			$item_output
		);
	}

	/**
	* Obtenir des champs personnalisés
	*/
	protected function get_fields( $item, $depth, $args = array(), $id = 0 ) {
		ob_start();
		/**
		* Obtenir des champs personnalisés à partir des plugins/thèmes du menu
		*/
		do_action( 'wp_nav_menu_item_custom_fields', $item->ID, $item, $depth, $args, $id );
		return ob_get_clean();
	}
}
