<?php
	function ghl_wp_enqueue() {
		global $wpdb, $ghl_define;

		$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
		$wp_select = "SELECT * from ".$wp_table_app;
		$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

		if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
			$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
		}

		wp_enqueue_style( md5('ghl_tpl/html_page/style.css'), ghl_plugin_url.'tpl/html_page/style.css', false );
		wp_enqueue_script( md5('ghl_script.js'.ghl_get_version()), ghl_plugin_url.'tpl/html_page/script.js',  'jquery', '1.0' );
		wp_localize_script( md5('ghl_script.js'.ghl_get_version()), 'frontEndAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
		wp_enqueue_script( 'jquery' );
		$post_type = get_post_type();
		$custom_css_style = '';
		$custom_menu_css_style = '';

		/**
		 * Gestion css du menu
		 */
			if(isset($wp_setting['general_setting']['html_elements']['cursor']['menu']) AND !empty($wp_setting['general_setting']['html_elements']['cursor']['menu'])){
				$custom_menu_css_style .= "cursor:".$wp_setting['general_setting']['html_elements']['cursor']['menu'].";";
			}
			if(isset($wp_setting['general_setting']['editor_css']['menu']) AND !empty($wp_setting['general_setting']['editor_css']['menu'])){
				$custom_menu_css_style .= $wp_setting['general_setting']['editor_css']['menu'];
			}
			if(isset($wp_setting['general_setting']['html_elements']['css']["menu"]) AND !empty($wp_setting['general_setting']['html_elements']['css']["menu"])){
				$class_mu = $wp_setting['general_setting']['html_elements']['css']["menu"];
			}else{
				$class_mu = 'ghl_buster_mu';
			}
			if(isset($wp_setting['general_setting']['html_elements']['data']["menu"]) AND !empty($wp_setting['general_setting']['html_elements']['data']["menu"])){
				$data_mu = $wp_setting['general_setting']['html_elements']['data']["menu"];
			}else{
				$data_mu = 'data-ghl';
			}
			if(!empty($custom_menu_css_style)){
				$custom_menu_css = ".".$class_mu."{".$custom_menu_css_style."}";
		     	wp_add_inline_style( md5('ghl_tpl/html_page/style.css'), $custom_menu_css );
			}

		/**
		 * Gestion css de la page
		 */
			if(isset($wp_setting['general_setting']['html_elements']['cursor'][$post_type]) AND !empty($wp_setting['general_setting']['html_elements']['cursor'][$post_type])){
				$custom_css_style .= "cursor:".$wp_setting['general_setting']['html_elements']['cursor'][$post_type].";";
			}
			if(isset($wp_setting['general_setting']['editor_css'][$post_type]) AND !empty($wp_setting['general_setting']['editor_css'][$post_type])){
				$custom_css_style .= $wp_setting['general_setting']['editor_css'][$post_type];
			}

			if(isset($wp_setting['general_setting']['html_elements']['css'][$post_type]) AND !empty($wp_setting['general_setting']['html_elements']['css'][$post_type])){
				$class_lk = $wp_setting['general_setting']['html_elements']['css'][$post_type];
			}else{
				$class_lk = 'ghl_buster_lk';
			}

			if(isset($wp_setting['general_setting']['html_elements']['data'][$post_type]) AND !empty($wp_setting['general_setting']['html_elements']['data'][$post_type])){
				$data_lk = $wp_setting['general_setting']['html_elements']['data'][$post_type];
			}else{
				$data_lk = 'data-ghl';
			}

			if(!empty($custom_css_style)){
				$custom_css = ".".$class_lk."{".$custom_css_style."}";
		     	wp_add_inline_style( md5('ghl_tpl/html_page/style.css'), $custom_css );
			}

		$custom_js = "var class_lk = '".$class_lk."'; var class_mu = '".$class_mu."'; var data_lk = '".$data_lk."'; var data_mu = '".$data_mu."';";
		wp_add_inline_script(md5('ghl_script.js'.ghl_get_version()), $custom_js );

	}
	add_action( 'wp_enqueue_scripts', 'ghl_wp_enqueue' );

	function ghl_content_link_ghost($content) {

		global $wpdb, $ghl_define;
		include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

		if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) {
			$page_id = get_page(get_the_ID());
			$exclud = [
				wc_get_page_id('myaccount'),
				wc_get_page_id('shop'),
				wc_get_page_id('cart'),
				wc_get_page_id('checkout')
			];
			$in_array = in_array($page_id->ID,$exclud);
		}

		if(!isset($in_array) OR !$in_array){
			$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
			$wp_select = "SELECT * from ".$wp_table_app;
			$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

			if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
				$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
			}

			if( isset($wp_setting['general_setting']['encryption']['links']) and $wp_setting['general_setting']['encryption']['links'] == "on" ){
				$ghl_encodage = 'AES';
			}else{
				$ghl_encodage = 'B64';
			}

			$content = do_shortcode( $content );
			preg_match_all('/href="(.*?)"/',$content,$all_url);
			$curl_data = [
				"request_method" => "PUT",
				"url" => "/wp/buster/",
				"auth" => "false",
				"postfileds" => [
				"json_encode" => true,
					"data" => [
						"ghl_links" => $all_url,
						"ghl_encodage" => $ghl_encodage
					]
				]
			];
			$curl = ghl_curl_request($curl_data);

			if($curl['info']['http_code'] == 200){
				$url_encrypt = $curl['resp']['success']['links'];
			}
			if(!empty($url_encrypt)){
				$link_ghost = preg_replace_callback('/<a(.*?)>(.*?)<\/a>/i',
				function($matches) use($url_encrypt){
					global $wpdb, $ghl_define;

					$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
					$wp_select = "SELECT * from ".$wp_table_app;
					$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

					if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
						$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
					}
					preg_match('/data-ghostlink="(.*?)"/',$matches[1],$data_ghl);

					$ghl_encrypt_link = false;
					$filter_skipped = false;
					$post_type = get_post_type();

					if(!empty($data_ghl[1])){
						$option_link = $data_ghl[1];
					}else{
						$option_link = 'link_default';
					}
					switch ($option_link) {
						case 'link_show':
							$ghl_encrypt_link = false;
							$filter_skipped = true;
						break;
						case 'link_hidden':
							$ghl_encrypt_link = true;
							$filter_skipped = true;
						break;
						default:
							$filter_skipped = false;
							if(isset($wp_setting['general_setting']['obfuscation']['links'][$post_type]) AND $wp_setting['general_setting']['obfuscation']['links'][$post_type] == 'on'){
								$ghl_encrypt_link = true;
							}
						break;
					}

					if($ghl_encrypt_link == true){
						preg_match('/href="(.*?)"/',$matches[1],$link_url);
						preg_match('/class="(.*?)"/',$matches[1],$link_class);
						$class = '';
						if(!empty($link_class[1])){
							$class = $link_class[1];
						}

						if($filter_skipped == false){
							if(isset($wp_setting['general_setting']['obfuscation']['type'][$post_type]) AND !empty($wp_setting['general_setting']['obfuscation']['type'][$post_type])){
								$ris = 'false';
								if(strpos($matches[2], 'img') !== false ){
									$ris = "true";
								}
								switch ($wp_setting['general_setting']['obfuscation']['type'][$post_type]) {
									case 'link_image':
										$check_continue = 1;
									break;
									case 'link':
										$check_continue = 0;
										if($ris == "false"){
											$check_continue = 1;
										}
									break;
									case 'image':
										$check_continue = 0;
										if($ris == "true"){
											$check_continue = 1;
										}
									break;
								}
							}else{
								$check_continue = 1;
							}
						}else{
							$check_continue = 1;
						}

						if($check_continue == 1){
							if(isset($wp_setting['general_setting']['html_elements']['tag'][$post_type]) AND !empty($wp_setting['general_setting']['html_elements']['tag'][$post_type])){
								$balise_tag = $wp_setting['general_setting']['html_elements']['tag'][$post_type];
							}else{
								$balise_tag = 'a';
							}
							if(isset($wp_setting['general_setting']['html_elements']['css'][$post_type]) AND !empty($wp_setting['general_setting']['html_elements']['css'][$post_type])){
								if(!empty($class)){
									$class .= ' ';
								}
								$class .= $wp_setting['general_setting']['html_elements']['css'][$post_type];
							}else{
								$class .= 'ghl_buster_lk';
							}
							if(isset($wp_setting['general_setting']['html_elements']['data'][$post_type]) AND !empty($wp_setting['general_setting']['html_elements']['data'][$post_type])){
								$data = $wp_setting['general_setting']['html_elements']['data'][$post_type];
							}else{
								$data = 'data-ghl';
							}

							return '<label><'.$balise_tag.' class="'.$class.'" '.$data.'="'.$url_encrypt[md5($link_url[1])].'">'.$matches[2].'</'.$balise_tag.'></label>';
						}else{
							return $matches[0];
						}
					}else{
						return $matches[0];
					}
				},$content);
			}else{
				$link_ghost = $content;
			}
			return $link_ghost;
		}else {
			return $content;
		}
	}
	add_filter( 'the_content','ghl_content_link_ghost', 9999 );
	add_filter( 'widget_text','ghl_content_link_ghost', 9999 );

	
	function ghl_custom_walker( $args ) {
		return array_merge( $args, array(
			'walker' => new ghl_cu_walker(),
		) );
	}
	add_filter( 'wp_nav_menu_args', 'ghl_custom_walker', 1, 1 );
	

	function ghl_custom_menu_item ( $items, $args ) {

		global $wpdb, $ghl_define;

		$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
		$wp_select = "SELECT * from ".$wp_table_app;
		$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

		if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
			$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
		}

		if( isset($wp_setting['general_setting']['encryption']['links']) and $wp_setting['general_setting']['encryption']['links'] == "on" ){
			$ghl_encodage = 'AES';
		}else{
			$ghl_encodage = 'B64';
		}

		$GLOBALS["ghl_menu_id"] = $args->menu->term_id;

		$theme_locations = get_nav_menu_locations();
		if(!empty($theme_locations['ghl-menu-link-hidden'])){
			$menu_obj = get_term( $theme_locations['ghl-menu-link-hidden'], 'nav_menu' );
		}
		preg_match_all( '/href="(.*?)"/', $items,$all_url );
		$curl_data = [
			"request_method" => "PUT",
			"url" => "/wp/buster/",
			"auth" => "false",
			"postfileds" => [
				"json_encode" => true,
				"data" => [
					"ghl_links" => $all_url,
					"ghl_encodage" => $ghl_encodage
				]
			]
		];
	   	$curl = ghl_curl_request($curl_data);
		if($curl['info']['http_code'] == 200){
			$url_encrypt = $curl['resp']['success']['links'];
		}
		if(!empty($url_encrypt)){

			$link_ghost = preg_replace_callback('/<a(.*?)>(.*?)<\/a>/i',
			function($matches) use($url_encrypt){
				global $wpdb, $ghl_define, $ghl_menu_id;

				$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
				$wp_select = "SELECT * from ".$wp_table_app;
				$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

				if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
					$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
				}
				preg_match('/data-ghostlink="(.*?)"/',$matches[1],$data_ghl);

				$ghl_encrypt_menu = false;

				if(!empty($data_ghl[1])){
					switch ($data_ghl[1]) {
						case 'link_show':
							$ghl_encrypt_menu = false;
						break;
						case 'link_hidden':
							$ghl_encrypt_menu = true;
						break;
						default:
							if(isset($wp_setting['general_setting']['obfuscation']['menu'][$ghl_menu_id]) AND $wp_setting['general_setting']['obfuscation']['menu'][$ghl_menu_id] == 'on'){
								$ghl_encrypt_menu = true;
							}
						break;
					}
				}

				if($ghl_encrypt_menu == true){
					preg_match('/href="(.*?)"/',$matches[1],$link_url);
					preg_match('/class="(.*?)"/',$matches[1],$link_class);
					$class = '';
					if(!empty($link_class[1])){
						$class = $link_class[1];
					}
					if(isset($wp_setting['general_setting']['html_elements']['tag']['menu']) AND !empty($wp_setting['general_setting']['html_elements']['tag']['menu'])){
						$balise_tag = $wp_setting['general_setting']['html_elements']['tag']['menu'];
					}else{
						$balise_tag = 'a';
					}
					if(isset($wp_setting['general_setting']['html_elements']['css']['menu']) AND !empty($wp_setting['general_setting']['html_elements']['css']['menu'])){
						if(!empty($class)){
							$class .= ' ';
						}
						$class .= $wp_setting['general_setting']['html_elements']['css']['menu'];
					}else{
						$class .= 'ghl_buster_mu';
					}
					if(isset($wp_setting['general_setting']['html_elements']['data']['menu']) AND !empty($wp_setting['general_setting']['html_elements']['data']['menu'])){
						$data = $wp_setting['general_setting']['html_elements']['data']['menu'];
					}else{
						$data = 'data-ghl';
					}
					return '<'.$balise_tag.' class="'.$class.'" '.$data.'="'.$url_encrypt[md5($link_url[1])].'">'.$matches[2].'</'.$balise_tag.'>';
				}else{
					return $matches[0];
				}
			},$items);
		}else{
			$link_ghost = $items;
		}
		return $link_ghost;
	}
	add_filter( 'wp_nav_menu_items', 'ghl_custom_menu_item', 10, 2 );
