<?php
	global $wpdb, $ghl_define;

	ghl_wizard();

	$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;
	$wp_select = "SELECT * from ".$wp_table_app;
	$ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

	if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
		$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
	}

	$curl_data = [
		"request_method" => "GET",
		"url" => "/wp/user/feature/",
		"auth" => "true",
		"postfileds" => [
			"json_encode" => true,
			"data" => [
				"features" => [
					"encryption_aes",
					"change_name_class",
					"change_name_tag",
					"edit_css_content"
				]
			]
		]
	];
	$curl_feature = ghl_curl_request($curl_data);
	if(isset($curl_feature['resp']['error'])){
		if($curl_feature['resp']['error']['name'] == "bad_wp_token" ){
			wp_redirect( admin_url( 'admin.php?page=ghl_auth_login' ) );
			exit;
		}
	}

	/**
	 * Récupération des template
	 */
		foreach (glob(dirname(__FILE__)."/tab_*/*.tpl") as $file_name) {
			if (is_file($file_name)) {
				$tag_name = str_replace('.tpl','',basename($file_name));
				$tpl_tg = new ghl_template($file_name);
				$ctd->set($tag_name, $tpl_tg->output());
			}
		}

	/**
	 * general_setting | obfuscation
	 */
		$wp_list_menu = __( 'No menu available', 'app_ghostlink' );
		$list_all_menus = get_terms('nav_menu');
		if(!empty($list_all_menus)){
			$wp_list_menu = '';
			foreach($list_all_menus as $list_menu){
				$obfuscation_menu = '';
				if(isset($wp_setting['general_setting']['obfuscation']['menu'][$list_menu->term_id]) AND $wp_setting['general_setting']['obfuscation']['menu'][$list_menu->term_id] == 'on'){
					$obfuscation_menu = 'checked';
				}
				$wp_list_menu .= '<div class="input-field s12"><div class="switch ghl_autosave_info"><label><input type="checkbox" class="ghl_autosave" name="general_setting|obfuscation|menu|'.$list_menu->term_id.'" '.$obfuscation_menu.'><span class="lever"></span>'.$list_menu->name.'</label></div><div class="ghl_additional_info">'.__( 'This option allows you to hide all links in this menu', 'app_ghostlink' ).'</div></div>';
			}
		}
		$ctd->set("wp_list_menu", $wp_list_menu);

		if(isset($wp_setting['general_setting']['obfuscation']['links']) and !empty($wp_setting['general_setting']['obfuscation']['links'])){
			foreach ($wp_setting['general_setting']['obfuscation']['links'] as $type => $value) {
				if($type == 'menu'){
					$list_all_menus = get_terms('nav_menu');
					if(!empty($list_all_menus)){
						foreach($list_all_menus as $list_menu){
							$checked = '';
							if(isset($value[$list_menu->term_id]) AND $value[$list_menu->term_id] == 'on'){
								$checked = 'checked="checked"';
							}
							$ctd->set("obfuscation_".$type."_".$list_menu->term_id, $checked);
						}
					}
				}else{
					$checked = '';
					if(isset($value) AND $value == 'on'){
						$checked = 'checked="checked"';
					}
					$ctd->set("obfuscation_".$type, $checked);
				}
			}
		}

	/**
	 * general_setting | encryption
	 */
	 if($curl_feature['resp']['success']['features']['encryption_aes']){
	 	$ctd->set("rs_encryption_links", '');
		$checked = '';
		if(isset($wp_setting['general_setting']['encryption']['links']) AND $wp_setting['general_setting']['encryption']['links'] == 'on'){
			$checked = 'checked="checked"';
		}
		$ctd->set("encryption_links", $checked);
	 }else{
	 	$ctd->set("rs_encryption_links", $ghl_define['app']['requires_sub']['msg']);
	 	$ctd->set("encryption_links", $ghl_define['app']['requires_sub']['input']);
	 }

	/**
	 * general_setting | html_elements
	 */
		$types = [
			"post",
			"page",
			"menu"
		];
		$options = [
			"a",
			"span"
		];
		$cursors = [
		    "default" => __( 'By default', 'app_ghostlink'),
		    "pointer" => __( 'Pointer', 'app_ghostlink'),
		    "inherit" => __( 'Normal', 'app_ghostlink'),
		];
		$links_type = [
		    "link_image" => __( 'Text and image links', 'app_ghostlink'),
		    "link" => __( 'Text links only', 'app_ghostlink'),
		    "image" => __( 'Image links only', 'app_ghostlink'),
		];
		foreach ($types as $type) {
			$hes_option = '';
			foreach ($options as $option) {
				if(isset($wp_setting['general_setting']['html_elements']['tag'][$type]) and $wp_setting['general_setting']['html_elements']['tag'][$type] == $option){
					$hes_option .= '<option value="'.$option.'" selected="selected">&lt;'.$option.'&gt;'.__('Text of your links','app_ghostlink').'&lt;/'.$option.'&gt;</option>';
				}else{
					$hes_option .= '<option value="'.$option.'">&lt;'.$option.'&gt;'.__('Text of your links','app_ghostlink').'&lt;/'.$option.'&gt;</option>';
				}
			}
			$ctd->set("hes_".$type, $hes_option);

			$cus_option = '';
			foreach ($cursors as $cursor_tag => $cursor_name) {
				if(isset($wp_setting['general_setting']['html_elements']['cursor'][$type]) and $wp_setting['general_setting']['html_elements']['cursor'][$type] == $cursor_tag){
					$cus_option .= '<option value="'.$cursor_tag.'" selected="selected">'.$cursor_name.'</option>';
				}else{
					$cus_option .= '<option value="'.$cursor_tag.'">'.$cursor_name.'</option>';
				}
			}
			$ctd->set("cus_".$type, $cus_option);

			$got_links_option = '';
			foreach ($links_type as $link_tag => $link_name) {
				if(isset($wp_setting['general_setting']['obfuscation']['type'][$type]) and $wp_setting['general_setting']['obfuscation']['type'][$type] == $link_tag){
					$got_links_option .= '<option value="'.$link_tag.'" selected="selected">'.$link_name.'</option>';
				}else{
					$got_links_option .= '<option value="'.$link_tag.'">'.$link_name.'</option>';
				}
			}
			$ctd->set("got_".$type, $got_links_option);

			$hec = '';
			if(isset($wp_setting['general_setting']['html_elements']['css'][$type]) AND !empty($wp_setting['general_setting']['html_elements']['css'][$type])){
				$hec = $wp_setting['general_setting']['html_elements']['css'][$type];
			}else{
				switch ($type) {
					case 'post':
						$hec = 'ghl_buster_lk';
					break;
					case 'page':
						$hec = 'ghl_buster_lk';
					break;
					case 'menu':
						$hec = 'ghl_buster_mu';
					break;
				}
			}

			if($curl_feature['resp']['success']['features']['change_name_class']){
				$ctd->set("rs_html_elements_css_".$type, '<div class="ghl_autosave_info ghl_progress_div dsgn_input_athow"><input class="athow_input ghl_autosave" name="general_setting|html_elements|css|'.$type.'"></input><div class="athow_content" contenteditable="true">'.$hec.'</div></div>');
			}else{
				$ctd->set("rs_html_elements_css_".$type, $ghl_define['app']['requires_sub']['msg']);
			}

			$hed = '';
			if(isset($wp_setting['general_setting']['html_elements']['data'][$type]) AND !empty($wp_setting['general_setting']['html_elements']['data'][$type])){
				$hed = $wp_setting['general_setting']['html_elements']['data'][$type];
			}else{
				$hed = 'data-ghl';
			}

			if($curl_feature['resp']['success']['features']['change_name_tag']){
				$ctd->set("rs_html_elements_tag_".$type, '<div class="ghl_autosave_info ghl_progress_div dsgn_input_athow"><input class="athow_input ghl_autosave" name="general_setting|html_elements|data|'.$type.'"></input><div class="athow_content" contenteditable="true">'.$hed.'</div></div>');
			}else{
				$ctd->set("rs_html_elements_tag_".$type, $ghl_define['app']['requires_sub']['msg']);
			}
		}

	/**
	 * general_setting | editor_css
	 */
		foreach ($types as $type) {
			if($curl_feature['resp']['success']['features']['edit_css_content']){
				$ctd->set("rs_editor_css_".$type, '<div class="r4w_autosave_info r4w_progress_div dsgn_input_athow">
					<input class="athow_input ghl_autosave" name="general_setting|editor_css|'.$type.'"></input>
					<textarea id="editor_css_'.$type.'" class="athow_content">[@editor_css_'.$type.']</textarea>
				</div>');
			}else{
				$ctd->set("rs_editor_css_".$type, $ghl_define['app']['requires_sub']['msg']);
			}
		}

		$ctd->set("editor_css_post", "");
		$ctd->set("editor_css_page", "");
		$ctd->set("editor_css_menu", "");
		if(isset($wp_setting['general_setting']['editor_css']) and !empty($wp_setting['general_setting']['editor_css'])){
			foreach ($wp_setting['general_setting']['editor_css'] as $type => $value) {
				if(isset($value)){
					$ctd->set("editor_css_".$type, $value);
				}
			}
		}
