<?php
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;
/**
 * API 1FR
 */
Class execUfr{
    public function __construct(){
        $bdd                  = new Database();
        $this->conn           = $bdd->dbConnection();
        $this->mail           = new PHPMailer(true);
        $this->tpl            = new Template();
    }
    //Essential::
        public function esl_report_error($a){
            foreach(config['send_rapport'] as $mail){
                $email = $mail['email'];
                $this->mail->isSMTP();
                $this->mail->Host = config['mail']['host'];
                $this->mail->SMTPAuth = true;
                $this->mail->Username = config['mail']['username'];
                $this->mail->Password = config['mail']['password'];
                $this->mail->SMTPSecure = config['mail']['secure'];
                $this->mail->SMTPOptions = config['mail']['option'];
                $this->mail->Port = config['mail']['port'];
                $this->mail->setFrom(config['mail']['from_address'], config['mail']['from_name']);
                $this->mail->addAddress($email);
                $this->mail->isHTML(true);
                $this->mail->CharSet = 'UTF-8';
                $this->mail->Subject = 'execUfr : Rapport sur une erreur';
                $this->mail->Body    = $this->tpl->mail_rapport($a,'execUfr');
                $this->mail->send();
            }
        }
    /**
    * FONCTION PERSONNALISER
    **/
    //::
        public function fcnt_ufr_request($a){
            $stmt = $this->conn->prepare("SELECT * FROM ufr_request_semantic WHERE document_uuid=:document_uuid");
            $stmt->execute([
                ':document_uuid'=> $a['document_uuid']
            ]);
            return $stmt->fetch(PDO::FETCH_ASSOC);
        }
    //::
        public function fcnt_ufr_clean(){
            if(is_file($file)){
                unlink(__DIR__.'/../../_tmp/cookie.txt');
            }
        }
    //::
        private function fcnt_ufr_status($a){
            $curl = curl_init();
            curl_setopt_array($curl, [
              CURLOPT_URL => hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['checking']['url_api']),
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_COOKIEFILE => __DIR__.'/../../_tmp/cookie.txt',
              CURLOPT_PROXY => api_proxy['proxy'],
              CURLOPT_PROXYUSERPWD => api_proxy['userpwd'],
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "GET"
            ]);
            $resp = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
              $this->esl_report_error($err);
            } else {
                if(strpos($resp,  hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['text_log_out'])) !== false) {
                    return true;
                }else{
                    return false;
                }
            }
        }
    //::
        private function fcnt_ufr_login($a){
            $postfileds = [
                "user[email]" => hex2bin(api_6170695f756e706f696e746672['email']),
                "user[password]" => hex2bin(api_6170695f756e706f696e746672['pwd']),
                "user[terms]" => 1
            ];
            $curl = curl_init();
            curl_setopt_array($curl, [
              CURLOPT_URL => hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['authentication']['url_api'])."?method=post",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_FOLLOWLOCATION => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_COOKIEFILE => __DIR__.'/../../_tmp/cookie.txt',
              CURLOPT_COOKIEJAR => __DIR__.'/../../_tmp/cookie.txt',
              CURLOPT_PROXY => api_proxy['proxy'],
              CURLOPT_PROXYUSERPWD => api_proxy['userpwd'],
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "POST",
              CURLOPT_POSTFIELDS => http_build_query($postfileds)
            ]);
            $resp = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
              $this->esl_report_error($err);
            } else {
                return true;
            }
        }
    /**
     * Envoie des requêtes sur l'api de un point fr
     * @param $a [Il s'agit de url avec les param]
     * @return result [Retourn en json la réponse de api]
     */
        private function AsynCurl($a){
        }
    /**
     * Enregistre dans la base de donnée
     * La semantique en rapport avec le document
     */
        private function ufr_semantics_text($a){
          function get_string_between($string, $start, $end){
               $string = ' ' . $string;
               $ini = strpos($string, $start);
               if ($ini == 0) return '';
               $ini += strlen($start);
               $len = strpos($string, $end, $ini) - $ini;
               return substr($string, $ini, $len);
          }
            $sementics_req = $this->fcnt_ufr_request($a, 'ufr_request_semantics');
            if(empty($sementics_req))
            {

                // API : Document semantics
                $sementics_request = $this->ufr_semantics_text_request($a);
                if(!empty($sementics_request)){
                    $sementics_request = preg_replace('#<strong class="font20 block">'.hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['text_div_lexical']).'</strong>#', '<strong id="r4w_box_lexical" class="font20 block">'.hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['text_div_lexical']).'</strong>', $sementics_request);
                    $b = str_get_html($sementics_request);
                    $c = $b->find('strong[id=r4w_box_lexical]',0)->parent();
                    unset($sementics_requests);
                    if(!empty($c)) {
                        $number_questions = 7;
                        $loop_question = 0;
                        foreach($c->find('div.bg_f5f7f7') as $d) {

                            $keywords = $d->find('strong.color_3a4a59', 0)->innertext;
                            //$averages = $d->find('span.bg_00afd8', 0);
                            //$averages = str_replace('%', '', $averages->innertext);
                            $averages = round(($number_questions - $loop_question) * 100 / $number_questions);

                            $words = $d->find('div[class=bg_f5f7f7 p20 rounded_sm border font13 lh20]', 0);
                            $words_gr = get_string_between($d, hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['text_bc_contains']).'&nbsp;&nbsp;', '...');
                            $words_arr = explode(", ", $words_gr);
                            $words_arr=array_map('trim',$words_arr);


                            $sementics_requests[] = [
                                "keywords" => $keywords,
                                "averages" => $averages,
                                "contexte" => $words_arr
                            ];
                            $loop_question++;
                        }
                    }else{
                        $sementics_requests = [];
                    }
                    // Ajoute la semantique
                    $stmt = $this->conn->prepare("INSERT INTO ufr_request_semantic(uuid,document_uuid,semantic) VALUES(:uuid,:document_uuid,:semantic)");
                    $stmt->bindValue(":uuid", fcnt_uuid());
                    $stmt->bindValue(":document_uuid", $a['document_uuid']);
                    $stmt->bindValue(":semantic", json_encode($sementics_requests));
                    $stmt->execute();
                    return $sementics_requests;
                }
            }else{
                // API : Document semantics
                $sementics_request = $this->ufr_semantics_text_request($a);
                if(!empty($sementics_request)){
                    $sementics_request = preg_replace('#<strong class="font20 block">'.hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['text_div_lexical']).'</strong>#', '<strong id="r4w_box_lexical" class="font20 block">'.hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['text_div_lexical']).'</strong>', $sementics_request);
                    $b = str_get_html($sementics_request);
                    $c = $b->find('strong[id=r4w_box_lexical]',0)->parent();
                    unset($sementics_requests);
                    if(!empty($c)) {

                        $number_questions = 7;
                        $loop_question = 0;

                        foreach($c->find('div.bg_f5f7f7') as $d) {

                            $keywords = $d->find('strong.color_3a4a59', 0)->innertext;
                            //$averages = $d->find('span.bg_00afd8', 0);
                            //$averages = str_replace('%', '', $averages->innertext);
                            $averages = round(($number_questions - $loop_question) * 100 / $number_questions);
                            $words = $d->find('div[class=bg_f5f7f7 p20 rounded_sm border font13 lh20]', 0);
                            $words_gr = get_string_between($d, hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['text_bc_contains']).'&nbsp;&nbsp;', '...');
                            $words_arr = explode(", ", $words_gr);
                            $words_arr=array_map('trim',$words_arr);

                            $sementics_requests[] = [
                                "keywords" => $keywords,
                                "averages" => $averages,
                                "contexte" => $words_arr
                            ];
                            $loop_question++;
                        }
                    }else{
                       $sementics_requests = [];
                    }
                    // Met à jour la semantique
                    $stmt = $this->conn->prepare("UPDATE ufr_request_semantic SET semantic=:semantic WHERE document_uuid=:document_uuid");
                    $stmt->bindValue(":document_uuid", $a["document_uuid"]);
                    $stmt->bindValue(":semantic", json_encode($sementics_requests));
                    $stmt->execute();
                    return $sementics_requests;
                }
            }
        }
    /**
     * Récupère la semantique du document
     */
        private function ufr_semantics_text_request($a){
            $asyn_param = [
                "text" => $a['content'],
                "query" => $a['query'],
                "country" => $a['country'],
                "language" => $a['language']
            ];
            if(!$this->fcnt_ufr_status($asyn_param)){
                $this->fcnt_ufr_clean();
                $this->fcnt_ufr_login($asyn_param);
            }
            $postfileds = [
                "utf8" => "✓",
                "engine" => "google",
                "ihavecontent" => 1,
                "query" => $asyn_param['query'],
                "request[text]" =>  $asyn_param['text']
            ];
            $curl = curl_init();
            curl_setopt_array($curl, [
                CURLOPT_URL => hex2bin(api_6170695f756e706f696e746672['method'][$a['language']]['optimize_text']['url_api']),
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_COOKIEFILE => __DIR__.'/../../_tmp/cookie.txt',
                CURLOPT_PROXY => api_proxy['proxy'],
                CURLOPT_PROXYUSERPWD => api_proxy['userpwd'],
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => http_build_query($postfileds)
            ]);
            $resp = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
              $this->esl_report_error($err);
            } else {
                return $resp;
            }
        }
    /**
     * Exectue et envoie les données à la bonne fonction
     * @param  [type] $a [nom de la function]
     * @param  [type] $b [les données a transmettre à la fonction]
     * @return [type]    [retour en fonction de la fonction]
     */
        public function execApp($a,$b){
            return $this->$a($b);
        }
}