<?php
	global $wpdb;
	$wp_table_option = $wpdb->prefix.'options';
	$wp_table_app = $wpdb->prefix.ghl_bdd_table_app;

	$wp_select = "SELECT * from ".$wp_table_app;
     $ghl_app = $wpdb->get_row($wp_select,ARRAY_A);

 	$wp_select = $wpdb->prepare("SELECT * FROM {$wp_table_option} WHERE option_name = %s",'blog_public');
 	$wp_options = $wpdb->get_row($wp_select,ARRAY_A);

     if(!empty($ghl_app['settings']) AND ctype_xdigit($ghl_app['settings'])){
 		$wp_setting = json_decode(hex2bin($ghl_app['settings']),true);
 	}
	if(!empty($ghl_app['wizard']) AND ctype_xdigit($ghl_app['wizard'])){
		$step_wizard = json_decode(hex2bin($ghl_app['wizard']),true);
	}

	$tpl_step = new ghl_template(dirname(__FILE__)."/step.tpl");
	$tpl_button = new ghl_template(dirname(__FILE__)."/button.tpl");
	$tpl_step_required = new ghl_template(dirname(__FILE__)."/step/required.tpl");
	$tpl_step_setting = new ghl_template(dirname(__FILE__)."/step/setting.tpl");

	$ctd->set( "step_screen", $tpl_step->output() );
	$ctd->set( "step_button", $tpl_button->output() );
	$ctd->set( "cancel",admin_url() );
	$ctd->set( "next_step", admin_url( 'admin.php?page=ghl_settings' ) );
	function ghl_step_menu($a){
		$menus = [
			[
				"title" => __( 'Identification', 'app_ghostlink' ),
				"description" => __( 'You need an account to use ghostlink login or create an account', 'app_ghostlink' ),
			],
			[
				"title" => __( 'System requirements', 'app_ghostlink' ),
				"description" => __( 'Lets check if your wordpress is compatible to run ghostlink', 'app_ghostlink' ),
			]
		];
		$i = 1;
		$tpl_menu = '';
		foreach ($menus as $menu) {
			$tpl_step_menu = new ghl_template(dirname(__FILE__)."/menu.tpl");
			$tpl_step_menu->set("menu_step", '<div class="css-d5d50sqdd">'.$i.'</div>');
			$tpl_step_menu->set("menu_class", '');
			if($a > $i){
				$tpl_step_menu->set("menu_step", ghl_assets_svg_code('check'));
				$tpl_step_menu->set("menu_class", 'class="complete"');
			}
			if($a == $i){
				$tpl_step_menu->set("menu_class", 'class="active"');
			}
			$tpl_step_menu->set("menu_title", $menu['title']);
			$tpl_step_menu->set("menu_description", $menu['description']);
			$i++;
			$tpl_menu .= $tpl_step_menu->output();
		}
		return $tpl_menu;
	}
	if(!isset($_GET['step'])){
		$_GET['step'] = '';
	}


	if(!empty($step_wizard['step']) AND !empty($_GET['step'])){
		if($_GET['step'] != md5($step_wizard['step'])){

		}
	}

	switch ($_GET['step']) {
		case 'c81e728d9d4c2f636f067f89cc14862c':
			$step = 2;
			$next = null;
		break;
		default:
			$step = 1;
			$next = 2;
		break;
	}

	switch ($step) {
		case 1:
			$ctd->set( "step_menu", ghl_step_menu(1) );
			$ctd->set( "step_content", __('Identification in progress, please wait...','app_ghostlink' ));

			$curl_data = [
				"request_method" => "GET",
				"url" => "/wp/account/",
				"auth" => "true",
				"postfileds" => [
					"json_encode" => true,
					"data" => null
				]
			];
			$curl_auth = ghl_curl_request($curl_data);

			if(empty($curl_auth['resp']['success'])){
				wp_redirect(get_admin_url('','admin.php?page=ghl_auth_login'));
				exit;
			}else{
				wp_redirect(get_admin_url('','admin.php?page=ghl_wizard&step='.md5(2)));
				exit;
			}
			break;
		case 2:
			if(!empty( $step_wizard['step'] )){
				if($step_wizard['step'] > $step){
					wp_redirect(get_admin_url('','admin.php?page=ghl_wizard&step='.md5($step_wizard['step'])));
					exit;
				}
			}
			$start_wizard = bin2hex(json_encode([
				"step" => 2
			]));
			$wpdb->query( $wpdb->prepare( "UPDATE $wp_table_app SET wizard = %s WHERE id = %d", $start_wizard, 1));

			$ctd->set("step_menu", ghl_step_menu(2));
			$ctd->set("step_content", $tpl_step_required->output());
			if(!empty($next)){
				$ctd->set("next_step", admin_url( 'admin.php?page=ghl_wizard&step='.md5($next) ));
			}else{
				$start_wizard = bin2hex(json_encode([
					"step" => 'finish'
				]));
				$wpdb->query( $wpdb->prepare( "UPDATE $wp_table_app SET wizard = %s WHERE id = %d", $start_wizard, 1));
			}

		  	$version_php = "failed";
		 	$version_wp = "failed";
		 	$domain_dns = "failed";
			$version_ghl = "failed";
		 	$domain_txt = __( 'No', 'app_ghostlink' );
			$https_domain = "failed";
			$https_domain_txt = __( 'No', 'app_ghostlink' );
			$curl_data = [
				"request_method" => "GET",
				"url" => "/wp/required/",
				"auth" => "true",
				"postfileds" => [
					"json_encode" => true,
					"data" => null
				]
			];
			$curl = ghl_curl_request($curl_data);
			if($curl['resp']['success']){
				$required = $curl['resp']['success']['required'];
			}
			if(phpversion() >= $required['php']){
				$version_php = "good";
			}
			$ctd->set("version_php_result", $required['php'].' '.__( 'or higher', 'app_ghostlink' ));
			$ctd->set("version_php_color", $version_php);

			if( get_bloginfo('version') >= $required['wordpress']){
				$version_wp = "good";
			}
			$ctd->set("version_wp_result", $required['wordpress'].' '.__( 'or higher', 'app_ghostlink' ));
			$ctd->set("version_wp_color", $version_wp);

			if(ghl_get_version() >= $required['ghostlink']){
				$version_ghl = "good";
			}
			$ctd->set("version_ghl_result", $required['ghostlink']);
			$ctd->set("version_ghl_color", $version_ghl);

			if($required['dns'] == true){
				$domain_dns = "good";
				$domain_txt = __( 'Yes', 'app_ghostlink' );
			}
			$ctd->set("domain_result", $domain_txt);
			$ctd->set("domain_color", $domain_dns);

			if(!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off'){
				$https_domain = "good";
				$https_domain_txt = __( 'Yes', 'app_ghostlink' );
			}
			$ctd->set("https_result", $https_domain_txt);
			$ctd->set("https_color", $https_domain);

			if($version_php == 'good' AND $version_wp == 'good' AND $version_ghl == 'good' AND $domain_dns == 'good'){
				$ctd->set("result_config", '<div class="css-5d0df5e"> <div class="css-f5r0hg8tnht">'.__( 'Congratulations, your configuration allows you to use ghostlink correctly. You can move on to the next step', 'app_ghostlink' ).'. </div> </div>');
				$ctd->set("btn_next_step", 'active');
			}else{
				$ctd->set("result_config", '<div class="css-5d0df5e"> <div class="css-5ef0erg5hry">'.__( 'Your configuration does not allow you to use ghostlink, to continue you must upgrade your configuration','app_ghostlink' ).'. </div> </div>');
				$ctd->set("btn_next_step", '');
			}
			break;
	}
